using Bp.Sync.BackEnd.Infrastructure.Repositories;
using Bp.Sync.Domain.Entities.Inventories.Categories;
using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using Microsoft.Extensions.Configuration;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Vina.Search.Infrastructure.Mappings;

namespace Bp.Sync.BackEnd.Application.Commands.Inventories.Categories
{
    public class SyncProductGroupHandler : MediatR.IRequestHandler<SyncProductGroupCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IProductGroupRepository _ProductGroupRepository;
        private readonly IBus _bus;

        public SyncProductGroupHandler(IConfiguration configuration, IProductGroupRepository ProductGroupRepository, IBus bus)
        {
            var connectionString = configuration.GetConnectionString("InventoryConnection");
            _dbConnection = new SqlConnection(connectionString);
            _ProductGroupRepository = ProductGroupRepository;
            _bus = bus;
        }

        public async Task<BaseResult> Handle(SyncProductGroupCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 1000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 1000; i++)
                    {
                        if (length > i * 1000)
                        {
                            var ids = request.Ids.Skip(i * 1000).Take(1000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticProductGroup", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} ProductGroups" };
            }
            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Dto.Results.Result.Success;
                return rs;
            }

            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var ProductGroups = await _dbConnection.QueryAsync<ProductGroup>("Sync_ProductGroup_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (ProductGroups.Any())
                {
                    var ProductGroupRs = ProductGroups.ToProductGroups();
                    var rs2 = await _ProductGroupRepository.AddManyAsync(ProductGroupRs);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_ProductGroup_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{ProductGroupRs.Count()} synced";
                        rs.Result = Result.Success;
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
            }
            return rs;
        }
    }
}